;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program - Drawing bezier curves (utah teapot wireframe)
;; without OpenGL using
;; author - Maciej Guba aka macgub
;; email  - macgub3@wp.pl
;; web -    macgub.hekko.pl
;; Thanks to lostcauz for intial version (I mean Windows
;; program template)
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
format PE GUI 4.0
entry start

include '/include/win32a.inc'

XRES equ 1280 ;1600 ;1200 ;800      ;choose screen size
YRES equ 1024 ; 900 ; 675 ;450
SIZE_X	equ XRES
SIZE_Y	equ YRES
ROUND equ 8
NON = 0
MMX = 1
SSE = 2
SSE2 = 3
SSE3 = 4
AVX = 5
Ext = SSE2


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    mov [bmi.biSize],sizeof.BITMAPINFOHEADER
    mov [bmi.biWidth],XRES
    mov [bmi.biHeight],-YRES
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],XRES
    mov [rect.bottom],YRES
    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0 

    invoke RegisterClass,wc

    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left] 

    invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
	   xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW

;    fninit                   ; prepare some variables
;    fild   [xres_var]
;    fst    dword[maxx]
;    fst    dword[maxx+4]
;    fst    dword[maxx+8]
;    fstp   dword[maxx+12]
;    fild   dword[yres_var]
;    fst    dword[maxy]
;    fst    dword[maxy+4]
;    fst    dword[maxy+8]
;    fstp   dword[maxy+12]

    invoke timeGetTime
    mov [s_time],eax	     ;initialize start time

msg_loop:
    invoke timeGetTime
    sub eax,[s_time]
    mov [e_time],eax	     ;get new end time

    stdcall g_draw
    inc  [ccounter]
    and  [ccounter],0x000000ff
    invoke StretchDIBits,[hdc],0,0,XRES,YRES,0,0,XRES,YRES,buffer,bmi,0,SRCCOPY
    invoke Sleep,2
  ;  call   update_p

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg

    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:
    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish
  .wmkeydown:
    cmp [wparam],VK_UP
    jne .vescape
;    stdcall g_init
    xor eax,eax
    jmp .finish
  .vescape:
    cmp [wparam],VK_ESCAPE
    jne .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish: 
    ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw uses ebx esi edi
local temp dw ?
local zz1 dw ?, zz2 dw ?, zz3 dw ?
local xx1 dw ?, xx2 dw ?, xx3 dw ?
local yy1 dw ?, yy2 dw ?, yy3 dw ?
    pushad
    fninit
    xor   eax,eax	   ; clear draw buffer
    mov   edi,buffer
    cld
    mov   ecx,XRES * YRES
    rep   stosd

  .rotate:
    fninit
    mov    esi,object
    mov    edi,object_rotated
    fild   [ccounter]
    fmul   [one_deg]
    fsincos
    fstp   [cos_beta]
    fstp   [sin_beta]
 @@:
    fld    dword[esi+4]
    fmul   [cos_beta]
    fld    dword[esi+8]
    fmul   [sin_beta]
    faddp
    fld    dword[esi+4]
    fmul   [sin_beta]
    fchs
    fld     dword[esi+8]
    fmul   [cos_beta]
    faddp
    fstp   dword[edi+8]
    fstp   dword[edi+4]
    push   dword[esi]
    pop    dword[edi]

    fld    dword[edi]
    fld    st
    fmul   [cos_beta]
    fld    dword[edi+8]
    fmul   [sin_beta]
    fchs
    faddp
    fstp   dword[edi]
    fmul   [sin_beta]
    fld    dword[edi+8]
    fmul   [cos_beta]
    faddp
    fstp   dword[edi+8]

    add    esi,12
    add    edi,12
    cmp    dword[esi],-1
    jnz    @b
    push   dword[esi]
    pop    dword[edi]




    xor   ebx,ebx
 .oop1:
    pushad
    mov   ecx,4
    cld
    lea   esi,[object_rotated+ebx]
    lea   edi,[p1x]
  @@:
    fld   dword[esi]
    fmul  [scale]
    fiadd [xxadd]
    fstp  dword[edi]
    fld   dword[esi+4]
    fmul  [scale]
    fiadd [yyadd]
    fstp  dword[edi+4]
    fld   dword[esi+8]
    fistp dword[edi+8]
    add   esi,12
    add   edi,12
    loop  @b
    call  draw_curve
    popad
    add    ebx,12*4
    cmp    ebx,12*8*64;12*28*8
    jng    .oop1



    xor   eax,eax
 .oop3:
    xor   ebx,ebx
 .oop2:
    pushad
    mov   ecx,4
    cld
    lea   esi,[object_rotated+ebx+eax]
    lea   edi,[p1x]
  @@:
    fld   dword[esi]
    fmul  [scale]
    fiadd [xxadd]
    fstp  dword[edi]
    fld   dword[esi+4]
    fmul  [scale]
    fiadd [yyadd]
    fstp  dword[edi+4]
    fld   dword[esi+8]
    fstp  dword[edi+8]

    add   esi,12*4
    add   edi,12
    loop  @b
    call  draw_curve
    popad
    add    ebx,12
    cmp    ebx,12*3
    jng    .oop2
    add    eax,12*16
    cmp    eax,12*16*32
    jng    .oop3
    popad
ret
endp



draw_curve:
if Ext >= AVX
    fninit
    fld1
    fidiv	  [maxcountervar]
    fst 	  [step]
    vbroadcastss  ymm0,[step]
    vmulps	  ymm1,ymm0,[const8]
    vmovaps	  [step8],ymm1

    vmulps	  ymm0,ymm0,[const1234]  ;5678
    vmovaps	  [t1],ymm0
    movzx	  eax,[maxcountervar]
    mov 	  ebx,eax
    shr 	  eax,3
    and 	  ebx,0x00000007
    mov 	  [rest],ebx
  .oop:
    push     eax

    call     calc_voxelAVX     ; 8 3d points at once


    pushad
    mov      ecx,XRES
    movaps   xmm0,[py1]
;    minps    xmm0,[maxy]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[px1]
;    minps    xmm1,[maxx]
;    maxps    xmm1,[minxy]
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff

    movaps   xmm0,[py5]
;    minps    xmm0,[maxx]
;    maxps    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[px5]
;    minps    xmm1,[maxy]
;    maxps    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff

    popad





    vmovaps  ymm4,[t1]
    vaddps   ymm4,ymm4,[step8]

    vmovaps [t1],ymm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .oop
else


    fninit
    fld1
    fidiv  [maxcountervar]
    fstp   [step]
    movss  xmm0,[step]
    mulps  xmm0,[const4]
    movaps [step4],xmm0

    movss  xmm0,[step]
    shufps xmm0,xmm0,0
    mulps  xmm0,[const1234]
    movaps [t1],xmm0
    movzx  eax,[maxcountervar]
    mov    ebx,eax
    shr    eax,2
    and    ebx,0x00000003    ; ebx -> rest
    mov    [rest],ebx
  .oop:
    push   eax

    call   calc_abcd
    call   calc_voxel

;===alternative2
    pushad
    mov      ecx,XRES
    movaps   xmm0,[py1]
;    minps    xmm0,[maxy]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[px1]
;    minps    xmm0,[maxx]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxx]
;    maxss    xmm0,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    popad

if 0				; putpixel
; ==aternative       won't works
    pushad
    mov      edx,XRES
    cvtsi2ss xmm0,edx
    shufps   xmm0,xmm0,0
    mulps    xmm0,[py1]
    addps    xmm0,[px1]
    cvtps2dq xmm0,xmm0
    pslld    xmm0,2
    mov      edx,buffer
    movd     xmm1,edx
    shufps   xmm1,xmm1,0
    paddd    xmm0,xmm1
    movd     eax,xmm0
    mov      [eax], dword 0x00ffffff
    psrldq   xmm0,4
    movd     eax,xmm0
    mov      [eax], dword 0x00ffffff
    psrldq   xmm0,4
    movd     eax,xmm0
    mov      [eax], dword 0x00ffffff
    psrldq   xmm0,4
    movd     eax,xmm0
    mov      [eax], dword 0x00ffffff
    popad
;==
end if
;;;;;;;;;;;;;;;;;




    movaps xmm4,[t1]
    addps  xmm4,[step4]

    movups [t1],xmm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .oop

end if









  .draw_last:
    mov    eax,[rest]
    or	   eax,eax
    jz	   .end
    push   dword[t4]
    pop    [t]
 .loop_rest:
    push   eax

    call   calc_abcd1
    call   calc_voxel1

    pushad
    mov      ecx,XRES
    movss  xmm0,[py]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movss   xmm1,[px]
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x00ffffff
    popad

    movss  xmm4,[t]
    addss  xmm4,[step4]

    movss  [t],xmm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .loop_rest
  .end:

ret
if Ext = AVX
calc_voxelAVX:
  vbroadcastss	ymm0,[const1]
  vmovaps	ymm1,[t1]
  vsubps	ymm0,ymm0,ymm1
  vmovaps	ymm3,ymm0
  vmovaps	ymm4,ymm0
  vmulps	ymm4,ymm4,ymm4
  vmulps	ymm7,ymm3,ymm4
 ; vmovaps       [a1],ymm3
  vmulps	ymm4,ymm4,[const3]
  vmulps	ymm6,ymm4,[t1]
 ; vmovaps       [b1],ymm4
  vmulps	ymm0,ymm0,[const3]
  vmulps	ymm1,ymm1,ymm1
  vmulps	ymm5,ymm0,ymm1
 ; vmovaps       [c1],ymm0
  vmulps	ymm1,ymm1,[t1]
  vmovaps	ymm4,ymm1

  vbroadcastss ymm0,[p1x]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[p2x]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[p3x]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[p4x]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [px1],ymm0

  vbroadcastss ymm0,[p1y]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[p2y]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[p3y]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[p4y]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [py1],ymm0

  vbroadcastss ymm0,[p1z]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[p2z]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[p3z]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[p4z]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [pz1],ymm0

ret
else
calc_abcd:

 movaps   xmm0,[const1]
 movaps   xmm1,[t1]
 subps	  xmm0,xmm1				    ;   a  = (1-t)^3
 movaps   xmm7,xmm0				    ;   b  = 3*(1-t)^2*t
 movaps   xmm6,xmm0				    ;   c  = 3*(1-t)*t^2
 mulps	  xmm6,xmm6				    ;   d  = t^3
 mulps	  xmm7,xmm6
 movaps   [a1],xmm7
 mulps	  xmm6,[const3]
 mulps	  xmm6,[t1]
 movaps   [b1],xmm6
 mulps	  xmm0,[const3]
 mulps	  xmm1,xmm1
 mulps	  xmm0,xmm1
 movaps   [c1],xmm0
 mulps	  xmm1,[t1]
 movaps   [d1],xmm1

ret

calc_voxel:

  movss   xmm0,[p1x]
  shufps  xmm0,xmm0,0
  mulps   xmm0,[a1]	  ;   px = a*p1x + b*p2x + c*p3x + d*p4x
  movss   xmm1,[p2x]
  shufps  xmm1,xmm1,0
  mulps   xmm1,[b1]
  movss   xmm2,[p3x]
  shufps  xmm2,xmm2,0
  mulps   xmm2,[c1]
  movss   xmm3,[p4x]
  shufps  xmm3,xmm3,0
  mulps   xmm3,[d1]
  addps   xmm0,xmm1
  addps   xmm2,xmm3
  addps   xmm0,xmm2
  movaps  [px1],xmm0	;  4 x coordinates at once


  movss   xmm0,[p1y]
  shufps  xmm0,xmm0,0
  mulps   xmm0,[a1]	  ;   px = a*p1x + b*p2x + c*p3x + d*p4x
  movss   xmm1,[p2y]
  shufps  xmm1,xmm1,0
  mulps   xmm1,[b1]
  movss   xmm2,[p3y]
  shufps  xmm2,xmm2,0
  mulps   xmm2,[c1]
  movss   xmm3,[p4y]
  shufps  xmm3,xmm3,0
  mulps   xmm3,[d1]
  addps   xmm0,xmm1
  addps   xmm2,xmm3
  addps   xmm0,xmm2
  movaps  [py1],xmm0	;  4 x coordinates at once


  movss   xmm7,[p1z]
  shufps  xmm7,xmm7,0
  mulps   xmm7,[a1]
  movss   xmm6,[p2z]
  shufps  xmm6,xmm6,0
  mulps   xmm6,[b1]
  movss   xmm5,[p3z]
  shufps  xmm5,xmm5,0
  mulps   xmm5,[c1]
  movss   xmm4,[p4z]
  shufps  xmm4,xmm4,0
  mulps   xmm4,[d1]
  addps   xmm4,xmm5
  addps   xmm6,xmm7
  addps   xmm4,xmm6
  movaps  [pz1],xmm4

ret
end if





draw_curve1:
    fninit
    fld1
    fidiv  [maxcountervar]
    fst    [step]
    fstp   [t]

    mov    ecx,1
  .oop:
    push   ecx

    call   calc_abcd1
    call   calc_voxel1
			    ; putpixel
    fld    [px]
    fistp  [ipx]
    fld    [py]
    fistp  [ipy]

    movzx  eax,[ipy]
    movzx  ebx,[ipx]
    mov    edx,XRES
    mul    edx
    add    eax,ebx
    shl    eax,2
    add    eax,buffer
    mov    [eax],dword -1

    fld    [t]
    fadd   [step]
    fstp   [t]

    pop    ecx
    inc    ecx
    cmp    cx,[maxcountervar]
    jnz    .oop

ret


calc_abcd1:

 fninit 				 ;   a  = (1-t)^3
 fld1					 ;   b  = 3*(1-t)^2*t
 fsub  [t]				 ;   c  = 3*(1-t)*t^2
 fld   st				 ;   d  = t^3
 fmul  st,st0
 fmulp
 fstp  [a]
 fld1
 fsub  [t]
 fmul  st,st0
 fimul [i3]
 fmul  [t]
 fstp  [b]
 fld1
 fsub  [t]
 fmul  [t]
 fmul  [t]
 fimul [i3]
 fstp  [c]
 fld   [t]
 fmul  st,st0
 fmul  [t]
 fstp  [d]
ret

calc_voxel1:

  fninit
  fld	[p1x]
  fmul	[a]
  fld	[p2x]
  fmul	[b]
  faddp
  fld	[p3x]
  fmul	[c]
  faddp
  fld	[p4x]
  fmul	[d]
  faddp
  fstp	[px]

  fld	[p1y]
  fmul	[a]
  fld	[p2y]
  fmul	[b]
  faddp
  fld	[p3y]
  fmul	[c]
  faddp
  fld	[p4y]
  fmul	[d]
  faddp
  fstp	[py]

  fld	[p1z]
  fmul	[a]
  fld	[p2z]
  fmul	[b]
  faddp
  fld	[p3z]
  fmul	[c]
  faddp
  fld	[p4z]
  fmul	[d]
  faddp
  fstp	[pz]
ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class TCHAR 'Bezier',0
    _title TCHAR 'Bezier curves  '
    if Ext = SSE2
      .exxt    TCHAR	  'sse2',0
    else
      .exxt    TCHAR	  'AVX',0
    end if
    _error TCHAR 'Startup failed.',0

    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0
    points_r:
      dd -1.0, -1.0, 1.0
      dd  1.0, -1.0, 1.0
      dd  0.0,	1.0, 0.0
      dd  0.0, -1.0, -1.0
      dd -1 ;<- end marker

    triangles:
       dw 0,2,1, 3,2,0, 1,2,3,	0,1,3
       dd -1 ;<- end marker

    scale    dd 3.3
    xxadd    dw XRES/2
    yyadd    dw YRES/2
    zzadd    dw 0
    xxadd1   dw XRES*3/4
    screen_width_var dd XRES
    xres_var dw XRES-1
    yres_var dw YRES-1
 ;   yyadd1   dw YRES*3/4
 ;   zzadd    dw 300
    one_deg  dd   0.024543692
    msg  MSG
    rect RECT


maxcountervar dw 200

step dd 0.05
i3   dw  3
f4   dd  4.0
align 16

const1:
 dd 1.0, 1.0, 1.0, 1.0
align 32
const3:
 dd 3.0, 3.0, 3.0, 3.0
 dd 3.0, 3.0, 3.0, 3.0
const4:
 dd 4.0, 4.0, 4.0, 4.0
align 32
const8:
 dd 8.0, 8.0, 8.0, 8.0, 8.0, 8.0, 8.0, 8.0
const1234:
 dd 1.0, 2.0, 3.0, 4.0
 dd 5.0, 6.0, 7.0, 8.0
minxy:
     dd  1.0, 1.0, 1.0, 1.0
p1x  dd  50.0
p1y  dd  50.0
p1z  dd  0.0

p2x  dd  25.0
p2y  dd  150.0
p2z  dd  0.0

p3x  dd  150.0
p3y  dd  150.0
p3z  dd  0.0

p4x  dd  125.0
p4y  dd  50.0
p4z  dd  0.0
 ;   P.x= (1-t)^3*P_1.x + 3*(1-t)^2*t*P_2.x + 3*(1-t)*t^2*P_3.x + t^3*P_4.x
 ;   P.y= (1-t)^3*P_1.y + 3*(1-t)^2*t*P_2.y + 3*(1-t)*t^2*P_3.y + t^3*P_4.y
 ;   P.z= (1-t)^3*P_1.z + 3*(1-t)^2*t*P_2.z + 3*(1-t)*t^2*P_3.z + t^3*P_4.z
 ;   px = a*p1x + b*p2x + c*p3x + d*p4x
 ;   a  = (1-t)^3
 ;   b  = 3*(1-t)^2*t
 ;   c  = 3*(1-t)*t^2
 ;   d  = t^3
 object:
include 'utah.inc'

    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_class
 object_rotated:
    rd	       65536
    ipx        dw ?
    ipy        dw ?
    counter    dw ?
align 32
 step8:
 step4:
    rd 4
    rd 4
    rd 4
    rd 4
align 16
    maxx:
      rd 4
    maxy:
      rd 4
align 32
 px1:	  dd ?
    px2   dd ?
    px3   dd ?
    px4   dd ?
 px5:
    rd	  4
 py1:	  dd ?
    py2   dd ?
    py3   dd ?
    py4   dd ?
 py5:
    rd	  4
 pz1:	  dd ?
    pz2   dd ?
    pz3   dd ?
    pz4   dd ?
 pz5:
    rd	  4
 t1:	 dd ?
    t2	 dd ?
    t3	 dd ?
    t4	 dd ?
    t5	 dd ?
    t6	 dd ?
    t7	 dd ?
    t8	 dd ?

 a1:	 dd ?
    a2	 dd ?
    a3	 dd ?
    a4	 dd ?
    rd	 4
 b1:	 dd ?
    b2	 dd ?
    b3	 dd ?
    b4	 dd ?
    rd	 4
 c1:	 dd ?
    c2	 dd ?
    c3	 dd ?
    c4	 dd ?
    rd	 4
 d1:	 dd ?
    d2	 dd ?
    d3	 dd ?
    d4	 dd ?
    rd	 4

    rest dd ?
    px	 dd ?
    py	 dd ?
    pz	 dd ?
    t	 dd ?
    a	 dd ?
    b	 dd ?
    c	 dd ?
    d	 dd ?
    cos_beta dd ?
    sin_beta dd ?
    hwnd     dd ?
    hdc      dd ?
    bmi      BITMAPINFOHEADER
    buffer  rd XRES*YRES


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM'

    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'

    import winmm,timeGetTime,'timeGetTime'
